package mn.geoProcessing.corte;

import org.cresques.cts.IProjection;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoprocessPaneContainer;
import com.iver.cit.gvsig.geoprocess.impl.intersection.IntersectionGeoprocessController;
import com.iver.cit.gvsig.geoprocess.wizard.AndamiCmd;
import com.iver.cit.gvsig.project.documents.view.gui.View;

public class CorteCmd implements AndamiCmd {

	public void execute() {
		View vista = (View)PluginServices.getMDIManager().getActiveWindow();
		MapContext mapContext = vista.getModel().getMapContext();
        FLayers layers = mapContext.getLayers();
        IProjection proj = mapContext.getProjection();
        String titleText = PluginServices.getText(this,
		"Corte._Introduccion_de_datos");
        GeoProcessingOverlayPanel dataSelectionPanel = 
			new GeoProcessingOverlayPanel(layers, titleText);
        GeoprocessPaneContainer container = new 
    		GeoprocessPaneContainer(dataSelectionPanel);
        CorteGeoprocessController controller =
        	new CorteGeoprocessController();
        controller.setView(dataSelectionPanel);
        container.setCommand(controller);
        container.validate();
        container.repaint();
        PluginServices.getMDIManager().addWindow(container);
	}

}

