

package mn.geoProcessing.corte;

import java.net.URL;
import java.util.Locale;

import org.cresques.cts.IProjection;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.GeoprocessPluginAbstract;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel2;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.impl.clip.ClipGeoprocessPlugin;
import com.iver.cit.gvsig.project.documents.view.gui.View;

public class CorteGeoprocessPlugin extends GeoprocessPluginAbstract implements IGeoprocessPlugin {
	
	//FIXME Esto es comun a todos los geoprocesos de overlay 
	//lo llevamos a una clase abstracta ?
	private static String analisisPkg;
	private static String overlayPkg;
	private static String geoprocessName;
	
	static{
		analisisPkg = PluginServices.getText(null, "Analisis");
		overlayPkg = PluginServices.getText(null, "Overlay");
		geoprocessName = PluginServices.getText(null, "Corte");
	}
	
	
	

	public IGeoprocessPanel getGeoprocessPanel() {
		View vista = (View)PluginServices.getMDIManager().getActiveWindow();
		MapContext mapContext = vista.getModel().getMapContext();
        FLayers layers = mapContext.getLayers();
        IProjection proj = mapContext.getProjection();
        String titleText = PluginServices.getText(this,
		"Interseccion._Introduccion_de_datos");
        GeoProcessingOverlayPanel2 dataSelectionPanel = 
			new GeoProcessingOverlayPanel2(layers, titleText);
        return dataSelectionPanel;
	}

	public URL getImgDescription() {
		return CorteGeoprocessPlugin.class.
		getResource("resources/cortedesc.png");
	}

	public IGeoprocessController getGpController() {
		return new CorteGeoprocessController();
	}

	public String getNamespace() {
		return analisisPkg + "/" + overlayPkg + "/" + geoprocessName;
	}

	public String toString(){
		return geoprocessName;
	}

}

