package mn.geoProcessing.area;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.drivers.SHPLayerDefinition;
import com.iver.cit.gvsig.fmap.edition.IWriter;
import com.iver.cit.gvsig.fmap.edition.ShpSchemaManager;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.geoprocess.core.fmap.AbstractGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.fmap.GeoprocessException;
import com.iver.cit.gvsig.geoprocess.core.fmap.IGeoprocess;
import com.iver.cit.gvsig.geoprocess.core.gui.AddResultLayerTask;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.utiles.swing.threads.IMonitorableTask;
import com.iver.utiles.swing.threads.MonitorableDecoratorMainFirst;
import com.iver.utiles.swing.threads.MonitorableTaskQueue;

public class AreaGeoprocessController extends AbstractGeoprocessController {

	private GeoProcessingAreaPanel geoProcessingAreaPanel;
	private AreaGeoprocess moArea;

	public void setView(IGeoprocessPanel viewPanel) {
		this.geoProcessingAreaPanel = (GeoProcessingAreaPanel)viewPanel;
	}

	public IGeoprocess getGeoprocess() {
		return moArea;
	}

	public boolean launchGeoprocess() {
		FLyrVect inputLayer = geoProcessingAreaPanel.getInputLayer();
		AreaGeoprocess loAreaGeo = new AreaGeoprocess(inputLayer);
		try {
			loAreaGeo.setNombreCapa(geoProcessingAreaPanel.getCapaSalida());
			loAreaGeo.setCalculoArea(geoProcessingAreaPanel.isCalculoArea());
			loAreaGeo.setCalculoPerimetro(geoProcessingAreaPanel.isCalculoPerimetro());
			loAreaGeo.setCampoArea(geoProcessingAreaPanel.getCampoArea());
			loAreaGeo.setCampoPerimetro(geoProcessingAreaPanel.getCampoPerimetro());
			loAreaGeo.checkPreconditions();

			PluginServices.cancelableBackgroundExecution(loAreaGeo.createTask());
		} catch (GeoprocessException e) {
			String error = PluginServices.getText(this, "Error_ejecucion");
			String errorDescription = PluginServices.getText(this, "Error_fallo_geoproceso");
			errorDescription = "<html>" + errorDescription + ":<br>" + e.getMessage()+ "</html>";
			geoProcessingAreaPanel.error(errorDescription, error);
			return false;
		}
		return true;
	}

	public int getWidth() {
		return 700;
	}

	public int getHeight() {
		return 400;
	}

}

//FLayers layers = geoProcessingAreaPanel.getFLayers();
//File outputFile = null;
//try {
//	outputFile = geoProcessingAreaPanel.getOutputFile();
//} catch (FileNotFoundException e3) {
//	String error = PluginServices.getText(this, "Error_entrada_datos");
//	String errorDescription = PluginServices.getText(this, "Error_seleccionar_resultado");
//	geoProcessingAreaPanel.error(errorDescription, error);
//	return false;
//}
//if (outputFile != null && outputFile.exists()) {
//	if (!geoProcessingAreaPanel.askForOverwriteOutputFile(outputFile)) {
//		return false;
//	}
//}
//if(outputFile!=null){
//	SHPLayerDefinition definition = (SHPLayerDefinition) loAreaGeo.createLayerDefinition();
//	definition.setFile(outputFile);
//	
//	ShpSchemaManager schemaManager = new ShpSchemaManager(outputFile.getAbsolutePath());
//	IWriter writer = null;
//	try {
//		writer = getShpWriter(definition);
//	} catch (Exception e1) {
//		String error = PluginServices.getText(this, "Error_escritura_resultados");
//		String errorDescription = PluginServices.getText(this, "Error_preparar_escritura_resultados");
//		geoProcessingAreaPanel.error(errorDescription, error);
//		return false;
//	}
//	loAreaGeo.setResultLayerProperties(writer, schemaManager);
//}
