package mn.geoProcessing.area;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.iver.utiles.extensionPoints.ExtensionPoints;
import com.iver.utiles.extensionPoints.ExtensionPointsSingleton;

public class AreaGeoprocessExtension extends Extension{

	private static final String mcsCalculoArea = "CalculoArea";
	public void initialize() {
		ExtensionPoints extensionPoints = 
			ExtensionPointsSingleton.getInstance();
		extensionPoints.add("GeoprocessManager",
				"Area", 
				AreaGeoprocessPlugin.class);
	}

	public void execute(String actionCommand) {
		if(mcsCalculoArea.equalsIgnoreCase(actionCommand)){
			new AreaCmd().execute();
        }		
	}

	public boolean isEnabled() {
		return true;
	}

	public boolean isVisible() {
        IWindow v =PluginServices.getMDIManager().getActiveWindow();
        if(v instanceof View){
    		View vista = (View)PluginServices.getMDIManager().getActiveWindow();
    		MapContext mapContext = vista.getModel().getMapContext();
            FLayers layers = mapContext.getLayers();
            return layers.getLayersCount()>0;
        }
        return false;
	}

}

