/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GeoProcessingAreaPanel.java
 *
 * Created on 28-ene-2009, 11:48:51
 */
package mn.geoProcessing.area;

import ListDatos.JFilaDatosDefecto;
import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.core.fmap.XTypes;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import utiles.JDepuracion;
import utilesGUIx.JComboBoxCZ;
import utilesGUIx.seleccionFicheros.JFileChooserFiltroPorExtension;

public class GeoProcessingAreaPanel extends JPanel implements IGeoprocessPanel, IWindow {

    private static final long serialVersionUID = 1L;
    
    public static final String mcsAREAMN="AREAMN";
    public static final String mcsPERIMEMN="PERIMEMN";
    
    protected FLayers layers = null;
	private WindowInfo viewInfo;

    /** Creates new form GeoProcessingAreaPanel */
    public GeoProcessingAreaPanel(FLayers layers, String psTitulo) {
        super();
        this.layers = layers;
        initComponents();
        lblTitulo.setText(psTitulo);
        //valores defecto area
        chkAREA.setSelected(true);
        optAREANuevoCampo.setSelected(true);
        txtAREANombreCampoNuevo.setText(mcsAREAMN);
        //valores defecto perimetro
        chkPERIMETRO.setSelected(false);
        optPERIMETRONuevoCampo.setSelected(true);
        txtPERIMETRONombreCampoNuevo.setText(mcsPERIMEMN);
        //valores defecto resultados
        optResultadoMismaCapa.setSelected(true);
        //valores defecto capa
        rellenarLayerNames(cmbCapas);
        cmbCapas.setSelectedIndex(0);
        //eventos manuales, por si no se han disparado por las acciones anteriores
        cmbCapasItemStateChanged(null);
        chkAREAStateChanged(null);
        chkPERIMETROStateChanged(null);
    }

    public WindowInfo getWindowInfo() {
		if (viewInfo == null) {
			viewInfo = new WindowInfo(WindowInfo.MODALDIALOG);
			viewInfo.setTitle(PluginServices
					.getText(this, "CalculoArea"));
		}
		return viewInfo;
    }

    public FLyrVect getInputLayer() {
        FLyrVect solution = null;
        String selectedLayer = (String) cmbCapas.getFilaActual().msCampo(0);
        solution = (FLyrVect) layers.getLayer(selectedLayer);
        return solution;
    }

    public void setFLayers(FLayers layers) {
        this.layers = layers;
    }

    public FLayers getFLayers() {
        return layers;
    }

    protected FLyrVect[] getVectorialLayers(FLayers layers) {
        FLyrVect[] solution = null;
        ArrayList list = new ArrayList();
        int numLayers = layers.getLayersCount();
        for (int i = 0; i < numLayers; i++) {
            FLayer layer = layers.getLayer(i);
            if (layer instanceof FLyrVect) {
                list.add(layer);
            } else if (layer instanceof FLayers) {
                list.addAll(Arrays.asList(getVectorialLayers((FLayers) layer)));
            }
        }
        solution = new FLyrVect[list.size()];
        list.toArray(solution);
        return solution;

    }

    protected void rellenarCamposNumericos(JComboBoxCZ poCmb, boolean pbArea) {
    	poCmb.borrarTodo();
    	String[] lasCampos = XTypes.getNumericFieldsNames(getInputLayer());
    	if(lasCampos!=null){
	    	for(int i = 0 ; i < lasCampos.length; i++){
	    		String lsCampo = lasCampos[i];
	    		poCmb.addLinea(lsCampo, lsCampo + JFilaDatosDefecto.mcsSeparacion1);
	    	}
	    	if(pbArea){
	    		poCmb.mbSeleccionarClave(mcsAREAMN + JFilaDatosDefecto.mcsSeparacion1);
	    	}else{
	    		poCmb.mbSeleccionarClave(mcsPERIMEMN + JFilaDatosDefecto.mcsSeparacion1);
	    	}
    	}
	}
    protected void rellenarLayerNames(JComboBoxCZ poCmb) {
        poCmb.borrarTodo();
        int numLayers = layers.getLayersCount();
        if (layers != null && numLayers > 0) {
            FLyrVect[] solution = getVectorialLayers(layers);
            for (int i = 0; i < solution.length; i++) {
                FLayer layer = solution[i];
                poCmb.addLinea(layer.getName(), layer.getName() + JFilaDatosDefecto.mcsSeparacion1);
            }//for
        }
    }

    /**
     * Shows to the user a dialog error, whith the title and message body
     * specified as parameters.
     *
     * @param message body of the error message
     * @param title title of the error message
     */
    public void error(String message, String title) {
        JFrame parentComponent = (JFrame) PluginServices.getMainFrame();
        JOptionPane.showMessageDialog(parentComponent, message, title,
                JOptionPane.ERROR_MESSAGE);
    }

    /**
     * Confirm overwrite the output file
     * if it allready exist.
     *
     *
     * @param outputFile
     * @return answer
     */
    public boolean askForOverwriteOutputFile(File outputFile) {
        String title = PluginServices.getText(this, "Sobreescribir_fichero");
        String confirmDialogText =
                PluginServices.getText(this, "Sobreescribir_fichero_Pregunta_1") +
                "\n'" +
                outputFile.getAbsolutePath() +
                "'\n" +
                PluginServices.getText(this, "Sobreescribir_fichero_Pregunta_2");
        int option = JOptionPane.showConfirmDialog(this,
                confirmDialogText,
                title,
                JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE, null);
        if (option == JOptionPane.YES_OPTION) {
            return true;
        }
        return false;
    }

//    /**
//     * Gives access to the text field where user could enter the result
//     * file path.
//     * If this method is called during the concrete gui subclasses building,
//     * caller must sets bounds of this component.
//     * @return
//     */
//    public JTextField getFileNameResultTextField() {
//        return txtCapaSalida;
//    }
    public String getCapaSalida(){
    	if(isMismaCapa()){
    		return null;
    	}else{
    		return txtCapaSalida.getText();
    	}
    }

    public boolean isCalculoArea(){
        return chkAREA.isSelected();
    }
    public boolean isCalculoPerimetro(){
        return chkPERIMETRO.isSelected();
    }
    public String getCampoArea(){
        if(optAREACampoExistente.isSelected()){
            return cmbAREACampos.getFilaActual().msCampo(0);
        }else{
            return txtAREANombreCampoNuevo.getText();
        }
    }
    public String getCampoPerimetro(){
        if(optPERIMETROCampoExistente.isSelected()){
            return cmbPERIMETROCampos.getFilaActual().msCampo(0);
        }else{
            return txtPERIMETRONombreCampoNuevo.getText();
        }
    }

    public boolean isMismaCapa(){
        return optResultadoMismaCapa.isSelected();
    }

//    public File getOutputFile() throws FileNotFoundException {
//        if(optResultadoNuevaCapa.isSelected()){
//            String fileName = getFileNameResultTextField().getText();
//            if (fileName.length() == 0) {
//                throw new FileNotFoundException("No se ha seleccionado ningun fichero de salida");
//            }
//            if (!fileName.endsWith(".shp")) {
//                if (!fileName.endsWith(".")) {
//                    fileName += ".";
//                }
//                fileName += "shp";
//            }
//            return new File(fileName);
//        }else{
//            return null;
//        }
//    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroupArea = new javax.swing.ButtonGroup();
        buttonGroupPerimetro = new javax.swing.ButtonGroup();
        buttonGroupResultado = new javax.swing.ButtonGroup();
        lblTitulo = new utilesGUIx.JLabelCZ();
        jLabelCZ1 = new utilesGUIx.JLabelCZ();
        cmbCapas = new utilesGUIx.JComboBoxCZ();
        jLabelCZ2 = new utilesGUIx.JLabelCZ();
        lblElementosSeleccionados = new utilesGUIx.JLabelCZ();
        chkAREA = new utilesGUIx.JCheckBoxCZ();
        jPanelAREACampo = new javax.swing.JPanel();
        optAREACampoExistente = new javax.swing.JRadioButton();
        cmbAREACampos = new utilesGUIx.JComboBoxCZ();
        optAREANuevoCampo = new javax.swing.JRadioButton();
        txtAREANombreCampoNuevo = new utilesGUIx.JTextFieldCZ();
        chkPERIMETRO = new utilesGUIx.JCheckBoxCZ();
        jPanelPERIMETROCampo = new javax.swing.JPanel();
        optPERIMETROCampoExistente = new javax.swing.JRadioButton();
        cmbPERIMETROCampos = new utilesGUIx.JComboBoxCZ();
        optPERIMETRONuevoCampo = new javax.swing.JRadioButton();
        txtPERIMETRONombreCampoNuevo = new utilesGUIx.JTextFieldCZ();
        jPanel1 = new javax.swing.JPanel();
        optResultadoNuevaCapa = new javax.swing.JRadioButton();
        txtCapaSalida = new utilesGUIx.JTextFieldCZ();
        optResultadoMismaCapa = new javax.swing.JRadioButton();

        setLayout(new java.awt.GridBagLayout());

        lblTitulo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTitulo.setText("Clculo Area y longitudes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(lblTitulo, gridBagConstraints);

        jLabelCZ1.setText("Capa de entrada");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(jLabelCZ1, gridBagConstraints);

        cmbCapas.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbCapas.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cmbCapasItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(cmbCapas, gridBagConstraints);

        jLabelCZ2.setText("Elementos seleccionados:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(jLabelCZ2, gridBagConstraints);

        lblElementosSeleccionados.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblElementosSeleccionados.setText("0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(lblElementosSeleccionados, gridBagConstraints);

        chkAREA.setText("Calcular rea");
        chkAREA.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                chkAREAStateChanged(evt);
            }
        });
        chkAREA.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkAREAItemStateChanged(evt);
            }
        });
        chkAREA.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                chkAREAFocusLost(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(chkAREA, gridBagConstraints);

        jPanelAREACampo.setBorder(javax.swing.BorderFactory.createTitledBorder("Calcular el AREA en campo:"));
        jPanelAREACampo.setLayout(new java.awt.GridBagLayout());

        buttonGroupArea.add(optAREACampoExistente);
        optAREACampoExistente.setText("Campo Existente");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelAREACampo.add(optAREACampoExistente, gridBagConstraints);

        cmbAREACampos.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelAREACampo.add(cmbAREACampos, gridBagConstraints);

        buttonGroupArea.add(optAREANuevoCampo);
        optAREANuevoCampo.setText("Nuevo Campo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelAREACampo.add(optAREANuevoCampo, gridBagConstraints);

        txtAREANombreCampoNuevo.setText(" ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelAREACampo.add(txtAREANombreCampoNuevo, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanelAREACampo, gridBagConstraints);

        chkPERIMETRO.setText("Calcular permetro/longitud");
        chkPERIMETRO.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                chkPERIMETROStateChanged(evt);
            }
        });
        chkPERIMETRO.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkPERIMETROItemStateChanged(evt);
            }
        });
        chkPERIMETRO.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                chkPERIMETROFocusLost(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        add(chkPERIMETRO, gridBagConstraints);

        jPanelPERIMETROCampo.setBorder(javax.swing.BorderFactory.createTitledBorder("Calcular el PERIMETRO/LONGITUD en campo:"));
        jPanelPERIMETROCampo.setLayout(new java.awt.GridBagLayout());

        buttonGroupPerimetro.add(optPERIMETROCampoExistente);
        optPERIMETROCampoExistente.setText("Campo Existente");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelPERIMETROCampo.add(optPERIMETROCampoExistente, gridBagConstraints);

        cmbPERIMETROCampos.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelPERIMETROCampo.add(cmbPERIMETROCampos, gridBagConstraints);

        buttonGroupPerimetro.add(optPERIMETRONuevoCampo);
        optPERIMETRONuevoCampo.setText("Nuevo Campo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelPERIMETROCampo.add(optPERIMETRONuevoCampo, gridBagConstraints);

        txtPERIMETRONombreCampoNuevo.setText(" ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanelPERIMETROCampo.add(txtPERIMETRONombreCampoNuevo, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanelPERIMETROCampo, gridBagConstraints);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Resultado"));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        buttonGroupResultado.add(optResultadoNuevaCapa);
        optResultadoNuevaCapa.setText("Nueva Capa en Memoria");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel1.add(optResultadoNuevaCapa, gridBagConstraints);

        txtCapaSalida.setText(" ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel1.add(txtCapaSalida, gridBagConstraints);

        buttonGroupResultado.add(optResultadoMismaCapa);
        optResultadoMismaCapa.setText("Misma capa");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel1.add(optResultadoMismaCapa, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void chkAREAStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_chkAREAStateChanged
        jPanelAREACampo.setEnabled(chkAREA.isSelected());

    }//GEN-LAST:event_chkAREAStateChanged

    private void chkPERIMETROStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_chkPERIMETROStateChanged
        jPanelPERIMETROCampo.setEnabled(chkPERIMETRO.isSelected());

    }//GEN-LAST:event_chkPERIMETROStateChanged

    private void cmbCapasItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cmbCapasItemStateChanged
        try{
	    	if (evt == null || evt.getStateChange() == ItemEvent.SELECTED) {
	            // ponemos los nombres de los campos
	            rellenarCamposNumericos(cmbAREACampos, true);
	            rellenarCamposNumericos(cmbPERIMETROCampos, false);
	            txtCapaSalida.setText(cmbCapas.getFilaActual().msCampo(0) + "Calculado");
	        }
        }catch(Exception e){
        	JDepuracion.anadirTexto(getClass().getName(), e);
        	if(evt != null){
        		utilesGUIx.msgbox.JMsgBox.mensajeError(this, e);
        	}
        }

    }//GEN-LAST:event_cmbCapasItemStateChanged

    private void chkAREAItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkAREAItemStateChanged
        chkAREAStateChanged(null);
    }//GEN-LAST:event_chkAREAItemStateChanged

    private void chkAREAFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_chkAREAFocusLost
        chkAREAStateChanged(null);
    }//GEN-LAST:event_chkAREAFocusLost

    private void chkPERIMETROFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_chkPERIMETROFocusLost
        chkPERIMETROStateChanged(null);
    }//GEN-LAST:event_chkPERIMETROFocusLost

    private void chkPERIMETROItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkPERIMETROItemStateChanged
        chkPERIMETROStateChanged(null);
    }//GEN-LAST:event_chkPERIMETROItemStateChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupArea;
    private javax.swing.ButtonGroup buttonGroupPerimetro;
    private javax.swing.ButtonGroup buttonGroupResultado;
    private utilesGUIx.JCheckBoxCZ chkAREA;
    private utilesGUIx.JCheckBoxCZ chkPERIMETRO;
    private utilesGUIx.JComboBoxCZ cmbAREACampos;
    private utilesGUIx.JComboBoxCZ cmbCapas;
    private utilesGUIx.JComboBoxCZ cmbPERIMETROCampos;
    private utilesGUIx.JLabelCZ jLabelCZ1;
    private utilesGUIx.JLabelCZ jLabelCZ2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanelAREACampo;
    private javax.swing.JPanel jPanelPERIMETROCampo;
    private utilesGUIx.JLabelCZ lblElementosSeleccionados;
    private utilesGUIx.JLabelCZ lblTitulo;
    private javax.swing.JRadioButton optAREACampoExistente;
    private javax.swing.JRadioButton optAREANuevoCampo;
    private javax.swing.JRadioButton optPERIMETROCampoExistente;
    private javax.swing.JRadioButton optPERIMETRONuevoCampo;
    private javax.swing.JRadioButton optResultadoMismaCapa;
    private javax.swing.JRadioButton optResultadoNuevaCapa;
    private utilesGUIx.JTextFieldCZ txtAREANombreCampoNuevo;
    private utilesGUIx.JTextFieldCZ txtCapaSalida;
    private utilesGUIx.JTextFieldCZ txtPERIMETRONombreCampoNuevo;
    // End of variables declaration//GEN-END:variables

}
