package mn.Impresion;

import com.iver.andami.PluginServices;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameView;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrame;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrameViewDependence;
import com.iver.cit.gvsig.project.documents.layout.fframes.gui.dialogs.FFrameViewDialog;
import com.iver.utiles.XMLEntity;
import mn.Impresion.gui.JPanelConDecoradores;

public class FFrameViewConDecoradores extends FFrameView implements IDecoradorado {
    protected List moListaDecoradores = new ArrayList();
    
    public IFFrame cloneFFrame(Layout layout) {
        FFrameViewConDecoradores frame = new FFrameViewConDecoradores();
        frame.setLevel(this.getLevel());
        frame.setNum(this.num);
        frame.setName(this.getName());
        frame.setBoundBox(this.getBoundBox());
        frame.setTag(this.getTag());
        frame.m_Mode = this.m_Mode;
        frame.m_typeScale = this.m_typeScale;
        frame.m_extension = this.m_extension;
        frame.m_quality = this.m_quality;
        frame.m_viewing = this.m_viewing;
        frame.m_bLinked = this.m_bLinked;
        frame.m_mapUnits = this.m_mapUnits;
        frame.setRotation(this.getRotation());

        frame.m_Scale = this.m_Scale;
        frame.view=this.getView();
        frame.m_fmap = this.getMapContext();
        frame.setSelected(this.getSelected()!=IFFrame.NOSELECT);
        frame.setLayout(layout);

        if (frame instanceof IFFrameViewDependence) {
            ((IFFrameViewDependence) frame).initDependence(layout.getAllFFrames());
        }
        cloneActions(frame);
        for(int i = 0 ; i < moListaDecoradores.size(); i++){
        	frame.addDecorador((IDecorador)moListaDecoradores.get(i) );
        }
        return frame;
    }
    public void setXMLEntity03(XMLEntity xml, Layout l) {
        super.setXMLEntity03(xml, l);
    }
    
    public void draw(Graphics2D g, AffineTransform at, Rectangle2D rv,
            BufferedImage imgBase) throws DriverException {
        
        super.draw(g, at, rv, imgBase);
        drawDecoradores(g, at, rv, imgBase);
        
    }
    
    private void drawDecoradores(Graphics2D g, AffineTransform at,
            Rectangle2D rv, BufferedImage imgBase) throws DriverException {
        for(int i = 0 ; i < moListaDecoradores.size(); i++){
            IDecorador loDec = (IDecorador)moListaDecoradores.get(i);
            loDec.draw(this, g, at, rv, imgBase);
        }
    }
    public void addDecorador(IDecorador poDecorador){
        moListaDecoradores.add(poDecorador);
    }
    public void deleteDecorador(IDecorador poDecorador){
        moListaDecoradores.remove(poDecorador);
    }

    
    public void print(Graphics2D g, AffineTransform at) throws DriverException {
        super.print(g, at);
    }

    public IFFrame getFFrame() {
        return this;
    }

    public void abrirPropiedadesConDecoradores(Layout layout) {
        FFrameViewDialog loFrame = new FFrameViewDialog(layout, this);
    	JPanelConDecoradores loProp = new JPanelConDecoradores(layout, loFrame, this);
        loProp.setVisible(true);
        
    }
    public List getListaDecoradores(){
        return moListaDecoradores;
    }
}
