package mn.Impresion;


import java.awt.Component;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrame;


public class LayoutDecoradoresPropiedadesExtension extends Extension{
    private static Logger logger = Logger.getLogger(LayoutDecoradoresPropiedadesExtension.class.getName());
    private Layout layout = null;
    /**
     * @see com.iver.andami.plugins.IExtension#initialize()
     */
    public void initialize() {
    }
    
    /**
     * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
     */
    public void execute(String s) {
        layout = (Layout) PluginServices.getMDIManager().getActiveWindow();
        
        IFFrame[] selectedFrames = layout.getFFrameSelected();
        for(int i = 0; i < selectedFrames.length; i++){
            IFFrame loFrame = selectedFrames[i];
            if(loFrame instanceof IDecoradorado){
                ((IDecoradorado)loFrame).abrirPropiedadesConDecoradores(layout);
            }
        }
    }
    
    /**
     * @see com.iver.andami.plugins.IExtension#isEnabled()
     */
    public boolean isEnabled() {
        IWindow f = PluginServices.getMDIManager().getActiveWindow();
        
        if (f == null) {
            return false;
        }
        
        if (f.getClass() == Layout.class) {
            layout = (Layout) f;
            IFFrame[] selectedFrames = layout.getFFrameSelected();
            if (selectedFrames == null) {
                return false;
            }else{
                for(int i = 0; i < selectedFrames.length; i++){
                    IFFrame loFrame = selectedFrames[i];
                    if(IDecoradorado.class.isAssignableFrom(loFrame.getClass()) ){
                        return true;
                    }
                }
            }
        }
        return false;
    }
    
    /**
     * @see com.iver.andami.plugins.IExtension#isVisible()
     */
    public boolean isVisible() {
        IWindow f = PluginServices.getMDIManager().getActiveWindow();
        
        if (f == null) {
            return false;
        }
        
        if (f instanceof Layout) {
            return true;
        }
        return false;
    }
    
}
