/*
 * JFormListaDecoradores.java
 *
 * Created on 31 de agosto de 2008, 11:21
 */

package mn.Impresion.gui;

import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;
import mn.Impresion.JDecoradorFactoria;
import mn.Impresion.JDecoradorFactoriaElemento;

/**
 *
 * @author  eduardo
 */
public class JFormListaDecoradores extends javax.swing.JDialog {
    private DecoradorListaTablaModel moModel;
    public static JDecoradorFactoriaElemento moDecorador;
    /** Creates new form JFormListaDecoradores */
    public JFormListaDecoradores(java.awt.Frame parent, boolean modal, String psClaseDecorado) {
        super(parent, modal);
        initComponents();
        
        List loListaDecoradores = JDecoradorFactoria.getListaDecoradores(psClaseDecorado);
        moModel = new DecoradorListaTablaModel(loListaDecoradores);
        jTableDecoradores.setModel(moModel);
                
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableDecoradores = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        btnAceptar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jTableDecoradores.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTableDecoradores);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        btnAceptar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mn/Impresion/images/accept.gif")));
        btnAceptar.setText("Aceptar");
        btnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAceptarActionPerformed(evt);
            }
        });

        jPanel1.add(btnAceptar);

        btnCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mn/Impresion/images/cancel.gif")));
        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        jPanel1.add(btnCancelar);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAceptarActionPerformed

        try{
            if(jTableDecoradores.getSelectedRow()>=0){
                moDecorador=moModel.getElemento(jTableDecoradores.getSelectedRow());
                dispose();
            }else{
                throw new Exception("Ninguna fila seleccionada");
            }
        }catch(Exception e){
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
        

    }//GEN-LAST:event_btnAceptarActionPerformed

    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
        moDecorador=null;
        dispose();
    }//GEN-LAST:event_btnCancelarActionPerformed
    

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAceptar;
    private javax.swing.JButton btnCancelar;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableDecoradores;
    // End of variables declaration//GEN-END:variables


}

class DecoradorListaTablaModel implements TableModel {
    private List moListaDecoradores;
    
    public DecoradorListaTablaModel(List poListaDecoradores){
        moListaDecoradores = poListaDecoradores;
        
    }
    
    public JDecoradorFactoriaElemento getElemento(int plIndex){
        return (JDecoradorFactoriaElemento) moListaDecoradores.get(plIndex);
    }
    
    public int getRowCount() {
        return moListaDecoradores.size();
    }

    public int getColumnCount() {
        return 1;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        JDecoradorFactoriaElemento loElem = (JDecoradorFactoriaElemento) moListaDecoradores.get(rowIndex);
        return loElem.getCaption();
    }

    public String getColumnName(int columnIndex) {
        return "Ttulo";
    }

    public Class getColumnClass(int columnIndex) {
        return String.class;
    }

    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return false;
    }

    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    }

    public void addTableModelListener(TableModelListener l) {
    }

    public void removeTableModelListener(TableModelListener l) {
    }
    
}
