/*
 * JPanelConDecoradores.java
 *
 * Created on 31 de agosto de 2008, 10:26
 */

package mn.Impresion.gui;
import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrame;
import com.iver.cit.gvsig.project.documents.layout.fframes.gui.dialogs.IFFrameDialog;
import com.iver.utiles.swing.jtable.JTable;
import java.awt.Frame;
import java.awt.geom.Rectangle2D;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import mn.Impresion.IDecorador;
import mn.Impresion.IDecoradorado;
import mn.Impresion.JDecoradorFactoria;
import mn.Impresion.JDecoradorFactoriaElemento;

/**
 *
 * @author  eduardo
 */
public class JPanelConDecoradores extends javax.swing.JDialog implements IFFrameDialog {
    private boolean mbAceptada=false;
    private IDecoradorado moDecorado;
    private IFFrameDialog moPanel;
    private Layout moLayout;

//    private List moListaDecoradores;

    private DecoradorTablaModel moModel;
    private WindowInfo m_viewinfo;
        
    /** Creates new form JPanelConDecoradores */
    public JPanelConDecoradores(Layout poLayout, IFFrameDialog poPanel, IDecoradorado poDecorado) {
        super(new Frame(), true);
        initComponents();

        moLayout = poLayout;
        moPanel = poPanel;
        moDecorado = poDecorado;
        poPanel.setRectangle(poDecorado.getFFrame().getBoundingBox(poLayout.getAT()));
        
//        jTabbedPane1.addTab("Propiedades", (JPanel)moPanel);

        mostrarDatos();
    }
    
    private void mostrarDatos(){
        moModel = new DecoradorTablaModel(moDecorado.getListaDecoradores());
        jTableDecoradores.setModel(moModel);
        jTableDecoradores.updateUI();
                
                
    }

    public void setRectangle(Rectangle2D r) {
        moDecorado.getFFrame().setBoundBox(r);
        moPanel.setRectangle(r);
    }
    
    public WindowInfo getWindowInfo() {
        
        
    	if (m_viewinfo == null) {
    	  m_viewinfo = new WindowInfo(WindowInfo.MODALDIALOG);
    	  m_viewinfo.setTitle(PluginServices.getText(this,
                "decoradores"));
      	}
        m_viewinfo.setNormalBounds(0,0,500,400);
        
        return m_viewinfo;
    }
    
    public boolean getIsAcepted() {
        return mbAceptada;
    }
    
    public IFFrame getFFrame() {
        return moDecorado.getFFrame();
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableDecoradores = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        btnSalir = new javax.swing.JButton();
        btnPropiedades = new javax.swing.JButton();
        btnAddDecorador = new javax.swing.JButton();
        btnBorrarDecorador = new javax.swing.JButton();

        jPanel1.setLayout(new java.awt.BorderLayout());

        jTableDecoradores.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTableDecoradores);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        btnSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mn/Impresion/images/exit.png")));
        btnSalir.setText("Salir");
        btnSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalirActionPerformed(evt);
            }
        });

        jPanel2.add(btnSalir);

        btnPropiedades.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mn/Impresion/images/gtk-about.png")));
        btnPropiedades.setText("Propiedades");
        btnPropiedades.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPropiedadesActionPerformed(evt);
            }
        });

        jPanel2.add(btnPropiedades);

        btnAddDecorador.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mn/Impresion/images/edit_add.png")));
        btnAddDecorador.setText("A\u00f1adir");
        btnAddDecorador.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddDecoradorActionPerformed(evt);
            }
        });

        jPanel2.add(btnAddDecorador);

        btnBorrarDecorador.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mn/Impresion/images/edit_delete.png")));
        btnBorrarDecorador.setText("Borrar");
        btnBorrarDecorador.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBorrarDecoradorActionPerformed(evt);
            }
        });

        jPanel2.add(btnBorrarDecorador);

        jPanel1.add(jPanel2, java.awt.BorderLayout.SOUTH);

        jTabbedPane1.addTab("Decoradores", jPanel1);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-548)/2, (screenSize.height-393)/2, 548, 393);
    }// </editor-fold>//GEN-END:initComponents

    private void btnPropiedadesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPropiedadesActionPerformed
        try{
            if(jTableDecoradores.getSelectedRow()>=0){
                moModel.getElemento(jTableDecoradores.getSelectedRow()).abrirPropiedades(
                        moDecorado, 
                        moLayout
                        );
                jTableDecoradores.updateUI();
            }else{
                throw new Exception("Ninguna fila seleccionada");
            }
        }catch(Exception e){
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, e.getMessage());
        }      
        
    }//GEN-LAST:event_btnPropiedadesActionPerformed

    private void btnBorrarDecoradorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBorrarDecoradorActionPerformed
        try{
            if(jTableDecoradores.getSelectedRow()>=0){
                moDecorado.deleteDecorador(moModel.getElemento(jTableDecoradores.getSelectedRow()));
                jTableDecoradores.updateUI();
            }else{
                throw new Exception("Ninguna fila seleccionada");
            }
        }catch(Exception e){
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, e.getMessage());
        }      
        
        
    }//GEN-LAST:event_btnBorrarDecoradorActionPerformed

    private void btnAddDecoradorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddDecoradorActionPerformed
        try{
            JFormListaDecoradores loLista = new  JFormListaDecoradores(new Frame(), true, moDecorado.getClass().getName());
            loLista.setVisible(true);
            if(loLista.moDecorador!=null){
                Class loDecoClass = Class.forName(loLista.moDecorador.getDecorador());
                IDecorador loDecorador = (IDecorador)loDecoClass.newInstance();
                moDecorado.addDecorador(loDecorador);
                jTableDecoradores.updateUI();
            }
        }catch(Exception e){
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }//GEN-LAST:event_btnAddDecoradorActionPerformed

    private void btnSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSalirActionPerformed
        dispose();
        
    }//GEN-LAST:event_btnSalirActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddDecorador;
    private javax.swing.JButton btnBorrarDecorador;
    private javax.swing.JButton btnPropiedades;
    private javax.swing.JButton btnSalir;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTableDecoradores;
    // End of variables declaration//GEN-END:variables
    
}

class DecoradorTablaModel implements TableModel {
    private List moListaDecoradores;
    
    DecoradorTablaModel(List poListaDecoradores){
        moListaDecoradores = poListaDecoradores;
        
    }
    
    public IDecorador getElemento(int plIndex){
        return (IDecorador) moListaDecoradores.get(plIndex);
    }
    
    public int getRowCount() {
        return moListaDecoradores.size();
    }

    public int getColumnCount() {
        return 1;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        IDecorador loElem = (IDecorador) moListaDecoradores.get(rowIndex);
        return loElem.getNombre();
    }

    public String getColumnName(int columnIndex) {
        return "Ttulo";
    }

    public Class getColumnClass(int columnIndex) {
        return String.class;
    }

    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return false;
    }

    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    }

    public void addTableModelListener(TableModelListener l) {
    }

    public void removeTableModelListener(TableModelListener l) {
    }
    
}