package mn.geoProcessing.area;

import java.net.URL;
import java.util.Locale;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.GeoprocessPluginAbstract;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel2;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.manager.GeoprocessManager;
import com.iver.cit.gvsig.project.documents.view.gui.View;

public class AreaGeoprocessPlugin extends GeoprocessPluginAbstract  implements IGeoprocessPlugin {
	private static String analisisPkg;
	private static String areaPkg;
	private static String areaPkgDesc;
	private static String geoprocessName;
	
	static{
		analisisPkg = PluginServices.getText(null, "Analisis");
		areaPkg = PluginServices.getText(null, "Area");
		areaPkgDesc = PluginServices.getText(null, "Area_Desc");
		geoprocessName = PluginServices.getText(null, "Area");
		
		GeoprocessManager.registerPackageDescription(
				analisisPkg + "/" + areaPkg,
						areaPkgDesc);

	}
	
	public IGeoprocessPanel getGeoprocessPanel() {
		View vista = (View)PluginServices.
			getMDIManager().
			getActiveWindow();
		FLayers layers = vista.getModel().
			getMapContext().
			getLayers();
		String titleText = PluginServices.getText(this,
			"Area._Introduccion_de_datos")
			+ ":";
		return new GeoProcessingAreaPanel(layers, titleText);
	}


	public URL getImgDescription() {
		return AreaGeoprocessPlugin.class.
		getResource("resources/areadesc.png");
	}

	public IGeoprocessController getGpController() {
		return new AreaGeoprocessController();
	}

	public String getNamespace() {
		return analisisPkg + "/" + 
				areaPkg + "/" + 
				geoprocessName;
	}

	public String toString(){
		return geoprocessName;
	}

}

