/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mn.geoProcessing.area;

import ListDatos.ECampoError;
import ListDatos.JListDatos;
import ListDatos.JListDatosFiltroConj;
import ListDatos.JServerServidorDatosFichero;
import utiles.JConversiones;

public class AreaUnidades {
    private static final String mcsM2= "m2";
    private static final String mcsHA2= "ha";
    private static final String mcsKM2= "km2";

    private static final String mcsM= "m";
    private static final String mcsKM= "km";


    public static final String mcsTipoSuperficie= "Superficie";
    public static final String mcsTipoLongitud= "Longitud";



    private JTUNIDADES moUnidades;

    private JServerServidorDatosFichero moServer;

    public AreaUnidades(){
        moServer = new JServerServidorDatosFichero(
                "./gvSIG/extensiones/mn.extensiones/",
                '#',
                true
                );
        recargar();
    }
    public JTUNIDADES getUnidades(){
        return moUnidades;
    }
    public void mostrarUnidades(){
        AreaFormUnidades loForm = new AreaFormUnidades(this);
        loForm.setVisible(true);
    }
    public void guardarUnidades() throws Exception{
        moServer.guardar(moUnidades.moList);
    }

    public void recargar() {
        moUnidades = new JTUNIDADES(moServer);
        try {
            moUnidades.recuperarTodosNormalSinCache();
        } catch (Throwable ex) {
        }
        if(!moUnidades.moList.moveFirst()){
            try {
                addLinea(mcsM, mcsTipoLongitud, 1);
                addLinea(mcsKM, mcsTipoLongitud, 0.001);
                addLinea(mcsM2, mcsTipoSuperficie, 1);
                addLinea(mcsHA2, mcsTipoSuperficie, 0.0001);
                addLinea(mcsKM2, mcsTipoSuperficie, 0.000001);
            } catch (ECampoError ex1) {
                ex1.printStackTrace();
            }
        }

    }
    private void addLinea(String psNombre , String pssTipo, double pdFactor) throws ECampoError {
        moUnidades.moList.addNew();
        moUnidades.getNOMBRE().setValue(psNombre);
        moUnidades.getTIPO().setValue(pssTipo);
        moUnidades.getFACTOR().setValue(pdFactor);
        moUnidades.moList.update(false);
    }

    private String[] getListaUnidades(String psTipo){
        String[] lasResult = null;
        try{
            moUnidades.moList.getFiltro().addCondicion(
                    JListDatosFiltroConj.mclAND,
                    JListDatos.mclTIgual,
                    moUnidades.lPosiTIPO,
                    psTipo);
            moUnidades.moList.filtrar();
            lasResult = new String[moUnidades.moList.size()];
            for(int i = 0 ; i < lasResult.length; i++){
                moUnidades.moList.setIndex(i);
                lasResult[i] = moUnidades.getNOMBRE().getString();
            }
        }finally{
            moUnidades.moList.getFiltro().Clear();
            moUnidades.moList.filtrarNulo();
        }
        return lasResult;
    }

    public String[] getListaUnidadesArea(){
        return getListaUnidades(mcsTipoSuperficie);
    }
    public String[] getListaUnidadesLongitud(){
        return getListaUnidades(mcsTipoLongitud);
    }
    public double getConvertirDeM2(final String psUnidad, final double pdM2, int plNumeroDecimales){
    	return JConversiones.numeroDecimales(
    			getConvertirDeM2(psUnidad, pdM2),
    			plNumeroDecimales);
    }
    public double getConvertirDeM2(final String psUnidad, final double pdM2){
        double ldResult = 0;
        if(moUnidades.moList.buscar(
                JListDatos.mclTIgual,
                new int[]{
                        moUnidades.lPosiNOMBRE,
                        moUnidades.lPosiTIPO
                },
                new String[]{
                    psUnidad,
                    mcsTipoSuperficie
                }
        ) ){
            ldResult = pdM2 * moUnidades.getFACTOR().getDouble();
        }
        return ldResult;
    }

    public double getConvertirDeM(final String psUnidad, final double pdM2, int plNumeroDecimales){
    	return JConversiones.numeroDecimales(
    			getConvertirDeM(psUnidad, pdM2),
    			plNumeroDecimales);
    }
    public double getConvertirDeM(final String psUnidad, final double pdM2){
        double ldResult = 0;
        if(moUnidades.moList.buscar(
                JListDatos.mclTIgual,
                new int[]{
                        moUnidades.lPosiNOMBRE,
                        moUnidades.lPosiTIPO
                },
                new String[]{
                    psUnidad,
                    mcsTipoLongitud
                }
        ) ){
            ldResult = pdM2 * moUnidades.getFACTOR().getDouble();
        }
        return ldResult;
    }

    public static void main(String[] pa){
        AreaUnidades loArea = new AreaUnidades();
        loArea.mostrarUnidades();
    }

}
