package mn.multivista.documents;

import java.awt.Component;
import java.util.List;

import javax.swing.JOptionPane;
import mn.multivista.documents.gui.MultiVistaDocumentGUI;

import mn.multivista.documents.gui.MultiVistaDocumentProperties;


import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.ErrorEvent;
import com.iver.cit.gvsig.fmap.ErrorListener;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.layers.XMLException;
import com.iver.cit.gvsig.project.Project;
import com.iver.cit.gvsig.project.documents.ProjectDocument;
import com.iver.cit.gvsig.project.documents.exceptions.OpenException;
import com.iver.cit.gvsig.project.documents.exceptions.SaveException;
import com.iver.cit.gvsig.project.documents.view.info.gui.HTMLInfoToolPanel;
import com.iver.utiles.XMLEntity;


/**
 * New MultiVistadocument.
 *
 * @author Eduardo Gonzalez Carpena
 */
public class MultiVistaDocument   
					extends ProjectDocument 
					implements ErrorListener {


	protected int m_typeLink = 0;
	protected String m_extLink;
	protected String m_selectedField = null;

	


	public void setXMLEntity(XMLEntity xml, Project p) throws XMLException,
			DriverException, DriverIOException, OpenException {	}

	public void setXMLEntity03(XMLEntity xml, Project p) throws XMLException,
			DriverException, DriverIOException { }

	public void showErrors(){
	
	}
	
	/**
	 * Reports to the user a bundle of driver exceptions produced in the
	 * same atomic MapContext transaction
	 */
	public void reportDriverExceptions(String introductoryText, List driverExceptions) {
		HtmlWindow htmlPanel = new HtmlWindow(570, 450, "Excepciones de driver");
		String htmlText = null;
		if(introductoryText == null){
			htmlText += "<p>Se han producido los siguientes errores durante la carga de capas.</p>";
		}else{
			htmlText += introductoryText;
		}
		int numErrors = driverExceptions.size();
		for(int i = 0; i < numErrors; i++){
			htmlText += "<br>\n";
			DriverException exception = (DriverException) driverExceptions.get(i);
			htmlText += exception.getExceptionType().getHtmlErrorMessage();
		}
		System.out.println(htmlText);
		htmlPanel.show(htmlText);
		
		PluginServices.getMDIManager().addCentredWindow(htmlPanel);
		
	}
	
	/**
	 * HtmlInfoToolPanel that implements IWindow
	 * @author azabala
	 *
	 */
	class HtmlWindow extends HTMLInfoToolPanel implements IWindow {
		WindowInfo viewInfo = null;
		public HtmlWindow(int width, int height, String windowTitle){
			viewInfo = new WindowInfo(WindowInfo.MODELESSDIALOG);
			viewInfo.setTitle(windowTitle);
			viewInfo.setWidth(width);
			viewInfo.setHeight(height);
		}
		
		public WindowInfo getWindowInfo() {
			return viewInfo;
		}
		
	}


	

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public String getExtLink() {
		return m_extLink;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public int getTypeLink() {
		return m_typeLink;
	}

	/**
     * Se selecciona la extensin para realizar cuando se quiera el link.
     *
     * @param s nombre del campo.
     */
	public void setExtLink(String s) {
		m_extLink = s;
	}

	/**
     * Se selecciona el tipo de fichero para realizar cuando se quiera el link.
     *
     * @param i tipo de fichero.
     */
	public void setTypeLink(int i) {
		m_typeLink = i;
	}

	public void afterRemove() {


	}

	public void afterAdd() {
	
	}



	public void errorThrown(ErrorEvent e) {
			JOptionPane.showMessageDialog((Component)PluginServices.getMainFrame(),
					PluginServices.getText(this,"fallo_capas")+" : \n"+
					e.getMessage());

	}

    public void errorThrown(Exception e) {
			JOptionPane.showMessageDialog((Component)PluginServices.getMainFrame(),
					e.getMessage());
    }	

	public String getFrameName() {
		return PluginServices.getText(this,"MultiVista");
	}

	public IWindow createWindow() {
		MultiVistaDocumentGUI view = new MultiVistaDocumentGUI();

		view.setModel(this);

		return view;
	}

	public IWindow getProperties() {
		return new MultiVistaDocumentProperties(this);
	}

	public void exportToXML(XMLEntity root, Project project)
			throws SaveException {
		// TODO Auto-generated method stub
		
	}

	public void importFromXML(XMLEntity root, XMLEntity typeRoot,
			int elementIndex, Project project, boolean removeDocumentsFromRoot)
			throws XMLException, DriverException, OpenException {
		// TODO Auto-generated method stub
		
	}



}
