package mn.multivista.documents.gui;

import com.iver.cit.gvsig.project.Project;
import com.iver.cit.gvsig.project.documents.ProjectDocument;
import com.iver.cit.gvsig.project.documents.view.ProjectViewFactory;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.List;
 
import javax.swing.JPanel;

import mn.multivista.documents.MultiVistaDocument;

import com.iver.andami.ui.mdiManager.IWindowListener;
import com.iver.andami.ui.mdiManager.IWindowTransform;
import com.iver.andami.ui.mdiManager.SingletonWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.project.documents.gui.WindowData;
import java.awt.geom.Rectangle2D;
import org.cresques.cts.IProjection;

public class MultiVistaGUI extends JPanel  implements IWindowListener, IWindowTransform, SingletonWindow, IListenerZoomMover{
    private static final long serialVersionUID = 5316449661673208275L;
    
    public static final int mclSincronizarCentroYEscala  = 0;
    public static final int mclSincronizarSoloCentro  = 1;
    public static final int mclSinSincronizar = 2;
    
    protected List moListaVistas = new ArrayList();
    protected WindowInfo m_viewInfo = null;
    protected MultiVistaDocument modelo;
    private int mlTipoSincronizacion = mclSincronizarCentroYEscala;
    private int mlVistaActivada = 0;
    
    private boolean mbVisualizarDespegablesVistas = true;

    private boolean mbAddVista=false;
    
    private List moListeners = new ArrayList();
    
    private IProjection moProyection;
    
    
    public MultiVistaGUI(){
        setLayout(new GridLayout());
        moProyection = Project.getDefaultProjection();
    }
    
    public void addListenerMultiVista(IMultivistaListener poListener){
        moListeners.add(poListener);
    }
    public void removeListenerMultiVista(IMultivistaListener poListener){
        moListeners.remove(poListener);
    }

    public List getTOCS() {
        List loResult = new ArrayList();
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            loResult.add(loV.getVistaGUI().getTOC());    
        }
        return loResult;
    }
    private void llamarListener(VistaSimpleYComboGUI poVistaYCombo){
        for(int i = 0; i < moListeners.size(); i++ ){
            IMultivistaListener loVista = (IMultivistaListener)moListeners.get(i);
            loVista.vistaCambiada(poVistaYCombo);
        }
    }
    
    protected  void removeVista(VistaSimpleYComboGUI poVista){
        poVista.getVistaGUI().removeListenerZoomMover(this);
        this.remove(poVista);
        moListaVistas.remove(poVista);
    }
    protected VistaSimpleYComboGUI addVista(){
        VistaSimpleYComboGUI loVista = new VistaSimpleYComboGUI(this);
    	mbAddVista = true;
    	try{
            moListaVistas.add(loVista);

            loVista.initialize();
            loVista.setProyect(modelo.getProject());
            loVista.setVisualizarDespegableVistas(isVisualizarDespegablesVistas());
            loVista.setBorder(javax.swing.BorderFactory.createEtchedBorder());
            loVista.getVistaGUI().addListenerZoomMover(this);

            //asignamos la siguiente vista dentro del conj. de vistas ya hechas
            ArrayList documents=modelo.getProject().getDocumentsByType(ProjectViewFactory.registerName);
            if(documents.size()>moListaVistas.size()-1){
                ProjectDocument doc=(ProjectDocument)documents.get(moListaVistas.size()-1);
                loVista.setProyectViewYCombo(doc.getName());
                setProyeccion(loVista, moProyection);
            }

            add(loVista);
        }finally{
        	mbAddVista=false;
        }
        return loVista;
    }

    public void setModel(MultiVistaDocument pomodel) {
        modelo=pomodel;
        setNumeroVistas(2);
        setVistaActivada(0);
        
    }
    
    protected void calculoDistribucion(int plNumero){
        int lColumn;
        int lRow;
        lColumn = 1;
        lRow = 1;
        if(plNumero==2){
            lColumn = 2;
            lRow = 1;
        }
        if(plNumero==3){
            lColumn = 3;
            lRow = 1;
        }
        if(plNumero==4){
            lColumn = 2;
            lRow = 2;
        }
        if(plNumero==6){
            lColumn = 3;
            lRow = 2;
        }
        if(plNumero==8){
            lColumn = 4;
            lRow = 2;
        }
        if(plNumero==9){
            lColumn = 3;
            lRow = 3;
        }
        if(plNumero==10){
            lColumn = 5;
            lRow = 2;
        }
        if(plNumero==12){
            lColumn = 4;
            lRow = 3;
        }
        
        ((GridLayout)getLayout()).setColumns(lColumn);
        ((GridLayout)getLayout()).setRows(lRow);
        
    }
    
    public void setNumeroVistas(int plNumero){
        //calculamos la distribucion
        calculoDistribucion(plNumero);
        //borramos vistas en caso necesario
        if(moListaVistas.size()>plNumero){
            while(moListaVistas.size() != plNumero){
                removeVista((VistaSimpleYComboGUI)moListaVistas.get(moListaVistas.size()-1));
            }
        }
        //aadimos vistas en caso necesario
        if(moListaVistas.size()<plNumero){
            while(moListaVistas.size() != plNumero){
                addVista();
            }
        }
        updateUI();
        //sincronizamos vistas
        zoomMover(getVistaActiva().getVistaGUI());
        //llamamos a los listener q ha cambiado la vista, no decimos cual pq puede haber muchas
        llamarListener(null);
    }
    public void setVisualizarDespegablesVistas(boolean pbVisible){
        mbVisualizarDespegablesVistas = pbVisible;
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            loV.setVisualizarDespegableVistas(pbVisible);
        }
    }
    public void setTipoSincronizacion(int plTipo){
        mlTipoSincronizacion  = plTipo;
        zoomMover(getVistaActiva().getVistaGUI());
    }
    
    /**
     * @see com.iver.mdiApp.ui.MDIManager.IWindow#windowActivated()
     */
    public void windowActivated() {
        getVistaActiva().getVistaGUI().windowActivated();
    }
    
    public void windowClosed() {
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            loV.getVistaGUI().windowClosed();
        }
    }
    
    public boolean isPalette() {
        return getVistaActiva().getVistaGUI().isPalette();
    }
    
    public void restore() {
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            loV.getVistaGUI().restore();
        }
    }
    
    public void toPalette() {
        getVistaActiva().getVistaGUI().toPalette();
    }
    
    public Object getWindowModel() {
        return modelo;
    }
    public void updateWindowData(WindowData windowData) {
        
    }
    public WindowInfo getWindowInfo() {
        if (m_viewInfo == null) {
            m_viewInfo = new WindowInfo(WindowInfo.ICONIFIABLE | WindowInfo.RESIZABLE |
                    WindowInfo.MAXIMIZABLE);
            
            m_viewInfo.setWidth(750);
            m_viewInfo.setHeight(550);
            m_viewInfo.setMaximized(true);
            m_viewInfo.setTitle("MultiVista");
        }
        return m_viewInfo;
    }
    
    public int getTipoSincronizacion() {
        return mlTipoSincronizacion;
    }
    
    public boolean isVisualizarDespegablesVistas() {
        return mbVisualizarDespegablesVistas;
    }
    
    public void refrescarDespegablesDeVistas() {
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            loV.rellenarDespegablesDeVistas();
        }
    }
    
    /**
     * ejecuta una accion para todas las vistas 
     * 
     * @param poEjecutar La accion
     * @throws java.lang.Throwable
     */
    public void ejecutarSobreVistas(IEjecutarSobreVista poEjecutar ) throws Throwable {
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            poEjecutar.ejecutar(loV);
        }
    } 

    /**
     * Sinbcroniza el centro en todas las vistas menos la Vista pasada por parametro
     * no sincroniza la escala
     * @param ldCentroX
     * @param ldCentroY
     * @param poVistaExcluir
     * @throws java.lang.Throwable
     */
    public void sincronizarCentro(final double ldCentroX , final double ldCentroY , final VistaSimpleGUI poVistaExcluir) throws Throwable{
        ejecutarSobreVistas(new IEjecutarSobreVista() {
            public void ejecutar(VistaSimpleYComboGUI loV) throws Throwable {
                if(loV.getVistaGUI()!=poVistaExcluir){
                    Rectangle2D loRectAux = loV.getVistaGUI().getMapControl().getMapContext().getViewPort().getExtent();
                    double ldX= ldCentroX - loRectAux.getWidth()/2;
                    double ldY= ldCentroY - loRectAux.getHeight()/2;
                    loRectAux.setRect(ldX, ldY, loRectAux.getWidth(), loRectAux.getHeight());
                    loV.getVistaGUI().getMapControl().getMapContext().getViewPort().setExtent(loRectAux);
                }
            }
        });
    }
    /**
     * Sincroniza centro y escala a todas las vistas menos a la pasada por parametro
     * @param loRect rectangulo a sincronizar
     * @param poVistaExcluir vista q no se sincroniza
     */
    public void sincronizarCentroYEscala(final Rectangle2D loRect, final VistaSimpleGUI poVistaExcluir) throws Throwable{
        ejecutarSobreVistas(new IEjecutarSobreVista() {
            public void ejecutar(VistaSimpleYComboGUI loV) throws Throwable {
                if(loV.getVistaGUI()!=poVistaExcluir){
                    loV.getVistaGUI().getMapControl().getMapContext().getViewPort().setExtent(loRect);
                }
            }
        });
    }
    
    /**
     * Se ejecuta cada vez q cambia el zoom o se a movido
     * @param poVista la vista q ha cambiado de zoom o se a movido
     */
    public void zoomMover(final VistaSimpleGUI poVista) {
        if(!mbAddVista && poVista == getVistaActiva().getVistaGUI()){
            //sincronizamos para q espere hasta q termine
            synchronized(this){
            try{
                final Rectangle2D loRect;
                switch(mlTipoSincronizacion){
                    case mclSincronizarCentroYEscala:
                        //conseguimos el rectangulo de visualizacion
                        loRect = poVista.getMapControl().getMapContext().getViewPort().getExtent();

                        //para cada vista la ponemos en el mismo sitio
                        sincronizarCentroYEscala(loRect, poVista);
                        break;
                    case mclSincronizarSoloCentro:
                        //calculamos el centro
                        loRect = poVista.getMapControl().getMapContext().getViewPort().getExtent();
                        final double ldCentroX = loRect.getX() + loRect.getWidth() / 2;
                        final double ldCentroY = loRect.getY() + loRect.getHeight() / 2;
                        
                        //para cada vista ponemos el centro
                        sincronizarCentro(ldCentroX, ldCentroY, poVista);

                        break;
                    case mclSinSincronizar:    
                    default:    
                        //nada
                }
            }catch (Throwable ex) {

            }finally{
            }
            }
        }
    }
    
    public VistaSimpleYComboGUI getVistaActiva(){
        VistaSimpleYComboGUI loResul=null;
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            if(loV.getActivada() && mlVistaActivada != i){
                    loV.setActivada(false, null);
            }
            if(!loV.getActivada() && mlVistaActivada == i){
                    loV.setActivada(true, null);
            }
            if(loV.getActivada() && mlVistaActivada == i){
                loResul = loV;
            }
        }
        if(loResul==null){
            setVistaActivada(0);
            loResul = (VistaSimpleYComboGUI)moListaVistas.get(0);
        }
        return loResul;
    }

    public void repaintMap() {
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            loV.getVistaGUI().repaintMap();
        }
    }

    private void setProyeccion(VistaSimpleYComboGUI poVista,IProjection proj){
        poVista.getVistaGUI().getMapControl().getMapContext().setProjection(proj);
    	
    }
    
    public void setProjection(IProjection proj) {
    	moProyection = proj;
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            setProyeccion(loV, proj);
        }
    }

    public void setVistaActivada(VistaSimpleYComboGUI poVista) {
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            if(loV == poVista){
                setVistaActivada(i);
            }
            
        }
    }
    
    

    public void vistaCambiada(VistaSimpleYComboGUI poVistaYCombo) {
      	setProyeccion(poVistaYCombo, moProyection);
        zoomMover(getVistaActiva().getVistaGUI());
        llamarListener(poVistaYCombo);
    }
    private void setVistaActivada(int plIndex) {
        if(plIndex >= moListaVistas.size()){
            mlVistaActivada = moListaVistas.size()-1;
        }else{
            if(plIndex < 0){
                mlVistaActivada = 0;
            }else{
                mlVistaActivada = plIndex;
            }
        
        }
        VistaSimpleYComboGUI loResult=null;
        String lsHerramienta=null;
        for(int i = 0 ; i < moListaVistas.size();i++){
            VistaSimpleYComboGUI loV = (VistaSimpleYComboGUI)moListaVistas.get(i);
            if(loV.getActivada()){
                lsHerramienta = loV.getVistaGUI().getMapControl().getCurrentTool();
            }
            if(mlVistaActivada == i){
                loResult = loV;
            }
        }
        
        loResult.setActivada(true, lsHerramienta);
        
        
        //sincronizamos vistas
        zoomMover(getVistaActiva().getVistaGUI());
    }
    
}
