/*
 * Vista.java
 *
 * Created on 20 de julio de 2008, 13:33
 */
package mn.multivista.documents.gui;

import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.tools.Behavior.Behavior;
import com.iver.cit.gvsig.fmap.tools.Behavior.PointBehavior;
import com.iver.cit.gvsig.fmap.tools.Behavior.RectangleBehavior;
import com.iver.cit.gvsig.project.Project;
import com.iver.cit.gvsig.project.documents.ProjectDocument;
import com.iver.cit.gvsig.project.documents.view.ProjectView;
import com.iver.cit.gvsig.project.documents.view.ProjectViewFactory;
import java.util.ArrayList;
import javax.swing.DefaultComboBoxModel;

public class VistaSimpleYComboGUI extends javax.swing.JPanel {

    private static final String mcsNeutraMultivista = "NeutraMultivista";
    private boolean mbanulareventos = false;
    private Project moProyect;
    private boolean mbActivada = false;
    private MultiVistaGUI moPadre;

//  private boolean mbInicio=false;
    /** Creates new form Vista */
    public VistaSimpleYComboGUI(MultiVistaGUI poPadre) {

        mbanulareventos = true;
        try {
            initComponents();
            cmbListaVistas.removeAllItems();
            moPadre = poPadre;
        //        moPanelEncima.setBackground(new Color(255,255,255,100));
        //        moPanelEncima1.setBackground(new Color(255,255,255,100));



        } finally {
            mbanulareventos = false;
        }
    }

    public void setProyect(Project poProyect) {
        mbanulareventos = true;
        try {
            moProyect = poProyect;
            rellenarDespegablesDeVistas();
        } finally {
            mbanulareventos = false;
        }
    }

    public void rellenarDespegablesDeVistas() {
        DefaultComboBoxModel model = null;

        ArrayList documents = moProyect.getDocumentsByType(ProjectViewFactory.registerName);

        model = new DefaultComboBoxModel(documents.toArray());

        String lsnombre = null;
        if (cmbListaVistas.getSelectedIndex() >= 0) {
            lsnombre = cmbListaVistas.getSelectedItem().toString();
        }
        cmbListaVistas.setModel(model);
        if (lsnombre != null) {
            setProyectViewYCombo(lsnombre);
        } else {
            if (cmbListaVistas.getSelectedIndex() >= 0) {
                setProyectView(cmbListaVistas.getSelectedItem().toString());
            }

        }

        cmbListaVistas.updateUI();

    }

    public void setProyectViewYCombo(String lsNombre) {
        setProyectView(lsNombre);
        mbanulareventos = true;
        try {
            for (int i = 0; i < cmbListaVistas.getModel().getSize(); i++) {
                if (cmbListaVistas.getModel().getElementAt(i).toString().equals(lsNombre)) {
                    cmbListaVistas.setSelectedIndex(i);
                }
            }
        } finally {
            mbanulareventos = false;
        }
    }

    private void addAccionNeutra() {
        MapControl mc = moVista.getMapControl();

        JMultivistaAccionNeutra loNeutra =
                new JMultivistaAccionNeutra(mc);
        loNeutra.setDatos(moPadre, this);
        mc.addMapTool(mcsNeutraMultivista,
                new Behavior[]{
                    new RectangleBehavior(loNeutra),
                    new PointBehavior(loNeutra)
                });
        mc.setTool(mcsNeutraMultivista);
    }

    public void setProyectView(String lsNombre) {
        ArrayList documents = moProyect.getDocumentsByType(ProjectViewFactory.registerName);
        for (int i = 0; i < documents.size(); i++) {
            ProjectDocument doc = (ProjectDocument) documents.get(i);
            if (doc.getName().equals(lsNombre)) {
                String lsHerramienta=null;
                if(getActivada() && moVista!=null){
                    lsHerramienta = moVista.getMapControl().getCurrentTool();
                }
                moVista.setModel((ProjectView) doc);
                addAccionNeutra();
                if(lsHerramienta!=null){
                	try{
                		moVista.getMapControl().setTool(lsHerramienta);
                	}catch(Throwable e){
                		moVista.getMapControl().setTool("zoomIn");
                	}                }
            }
        }
        if (!mbanulareventos) {
            moPadre.vistaCambiada(this);
        }
    }

    public void initialize() {
        moVista.initialize();


    }

    public VistaSimpleGUI getVistaGUI() {
        return moVista;

    }

    public void setVisualizarDespegableVistas(boolean pbVisible) {
        jPanelControl.setVisible(pbVisible);
    }

    public void setActivada(boolean b, String psToolActiva) {
        mbActivada = b;
        if (b) {
            getVistaGUI().windowActivated();
            moVista.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED, new java.awt.Color(255, 0, 0), new java.awt.Color(255, 0, 0), java.awt.Color.red, java.awt.Color.red));
            if(psToolActiva == null || psToolActiva.equals("")){
                moVista.getMapControl().setTool("zoomIn");
            }else{
            	try{
            		moVista.getMapControl().setTool(psToolActiva);
            	}catch(Throwable e){
            		moVista.getMapControl().setTool("zoomIn");
            	}
            }
        } else {
            getVistaGUI().windowClosed();
            moVista.setBorder(null);
            moVista.getMapControl().setTool(mcsNeutraMultivista);

        }
        jToggleButtonActivar.setSelected(b);

    }

    public boolean getActivada() {
        return mbActivada;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanelControl = new javax.swing.JPanel();
        cmbListaVistas = new javax.swing.JComboBox();
        jToggleButtonActivar = new javax.swing.JToggleButton();
        moVista = new mn.multivista.documents.gui.VistaSimpleGUI();

        setLayout(new java.awt.BorderLayout());

        jPanelControl.setLayout(new java.awt.GridBagLayout());

        cmbListaVistas.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbListaVistas.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cmbListaVistasItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanelControl.add(cmbListaVistas, gridBagConstraints);

        jToggleButtonActivar.setText("Activar");
        jToggleButtonActivar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonActivarActionPerformed(evt);
            }
        });
        jPanelControl.add(jToggleButtonActivar, new java.awt.GridBagConstraints());

        add(jPanelControl, java.awt.BorderLayout.NORTH);

        moVista.setLayout(new java.awt.BorderLayout());
        add(moVista, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void cmbListaVistasItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cmbListaVistasItemStateChanged
        if (!mbanulareventos) {
            String lsNombre = cmbListaVistas.getSelectedItem().toString();
            setProyectView(lsNombre);
        }

    }//GEN-LAST:event_cmbListaVistasItemStateChanged

private void jToggleButtonActivarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonActivarActionPerformed
    if (!mbanulareventos) {
        moPadre.setVistaActivada(this);
    }
}//GEN-LAST:event_jToggleButtonActivarActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JComboBox cmbListaVistas;
    private javax.swing.JPanel jPanelControl;
    private javax.swing.JToggleButton jToggleButtonActivar;
    private mn.multivista.documents.gui.VistaSimpleGUI moVista;
    // End of variables declaration//GEN-END:variables
}
