/*
 * JEnlaceGVGisSeleccion.java
 *
 * Created on 6 de septiembre de 2007, 10:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package mn.vistaSuperpuesta;

import com.iver.cit.gvsig.fmap.ColorEvent;
import com.iver.cit.gvsig.fmap.ExtentEvent;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ProjectionEvent;
import com.iver.cit.gvsig.fmap.ViewPortListener;
import com.iver.cit.gvsig.fmap.layers.LayerEvent;
import com.iver.cit.gvsig.fmap.layers.LayerListener;
import com.iver.cit.gvsig.fmap.tools.BehaviorException;
import com.iver.cit.gvsig.fmap.tools.Events.PointEvent;
import com.iver.cit.gvsig.project.documents.view.IProjectView;
import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;

import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import javax.swing.ImageIcon;

public class JVistaSuperpuestaAccion implements MouseMotionListener  , ViewPortListener, LayerListener {
    private final Image izoomout = new ImageIcon(JVistaSuperpuestaAccion.class.getResource(
            "/images/cursor.gif")).getImage();
    private Cursor cur = Toolkit.getDefaultToolkit().createCustomCursor(izoomout,
            new Point(16, 16), "");
    
    private MapControl mapControl = null;
    
    private JVistaSuperpuestaPintor moPintor;
    private JVistaSuperpuestaParam moParam;
//    private Thread moPintorThread;
    
    
    public JVistaSuperpuestaAccion(){
        
    }
    
    public void setDatos(final MapControl mapControl, IProjectView poProyect, JVistaSuperpuestaParam poParam){
        this.mapControl = mapControl;
        
        borrarListeners();
        
        mapControl.getViewPort().addViewPortListener(this);
        mapControl.getMapContext().getLayers().addLayerListener(this);
        mapControl.addMouseMotionListener(this);
        
        moParam = poParam;
        
        try {
            moPintor = new JVistaSuperpuestaPintor(moParam, mapControl,this);
//			moPintorThread = new Thread(moPintor);
//			moPintorThread.start();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    private void borrarListeners(){
        mapControl.getViewPort().removeViewPortListener(this);
        mapControl.getMapContext().getLayers().removeLayerListener(this);
        mapControl.removeMouseMotionListener(this);
    }
    public void terminado(){
        borrarListeners();
        moPintor.terminar();
    }
    
    public JVistaSuperpuestaParam getParam(){
        return moParam;
    }
    
    
    public boolean cancelDrawing() {
        return true;
    }
    public Cursor getCursor() {
        return cur;
    }
    
    
    
    private void pintar(int x, int y){
        moPintor.setCoordenadas(x, y);
        moPintor.pintar();
//        mapControl.getMapContext().clearAllCachingImageDrawnLayers();
    }
    
    
    public void mouseDragged(MouseEvent e) {
        pintar( e.getX(),
                e.getY()
                );
    }

    public void mouseMoved(MouseEvent e) {
        pintar( e.getX(),
                e.getY()
                );
    }
    public void point(PointEvent event) throws BehaviorException {
        pintar( event.getEvent().getX(),
                event.getEvent().getY()
                );
    }
    
    public void pointDoubleClick(PointEvent event) throws BehaviorException {
        pintar( event.getEvent().getX(),
                event.getEvent().getY()
                );
    }
    
    
    
    public void backColorChanged(ColorEvent e) {
        try {
            moPintor.capturarImagenes();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        
    }
    public void extentChanged(ExtentEvent e) {
        try {
            moPintor.capturarImagenes();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        
    }
    public void projectionChanged(ProjectionEvent e) {
        try {
            moPintor.capturarImagenes();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        
    }
    
    
    public void activationChanged(LayerEvent e) {
//        try {
//                moPintor.capturarImagenes();
//        } catch (Exception e1) {
//                e1.printStackTrace();
//        }
    }
    
    
    public void editionChanged(LayerEvent e) {
        try {
            moPintor.capturarImagenes();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
    }
    
    
    public void nameChanged(LayerEvent e) {
//        try {
//                moPintor.capturarImagenes();
//
//        } catch (Exception e1) {
//                e1.printStackTrace();
//        }
    }
    
    
    public void visibilityChanged(LayerEvent e) {
        try {
            moPintor.capturarImagenes();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
    }

    
}
