package mn.vistaSuperpuesta;

import com.iver.cit.gvsig.project.Project;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;

import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.project.documents.ProjectDocument;
import com.iver.cit.gvsig.project.documents.view.ProjectView;
import com.iver.cit.gvsig.project.documents.view.ProjectViewFactory;

public class JVistaSuperpuestaFuenteVIEW implements IVistaSuperpuestaFuente {

	private String msNombrevista;
	private Project moProyect;
	public JVistaSuperpuestaFuenteVIEW(String psNombrevista, Project poProyect ){
		msNombrevista = psNombrevista;
		moProyect=poProyect;
	}
	public Image getImage(int plWidth, int plHeight, Rectangle2D poRect) {
		BufferedImage loImage = new BufferedImage(plWidth, plHeight, BufferedImage.TYPE_INT_ARGB);
		Graphics2D loGra = (Graphics2D)loImage.getGraphics();
        loGra.setColor(Color.white);
        loGra.drawRect(0 , 0 , plWidth, plHeight);
        
		ArrayList documents = moProyect.getDocumentsByType(ProjectViewFactory.registerName);
	    for (int i = 0; i < documents.size(); i++) {
	        ProjectDocument doc = (ProjectDocument) documents.get(i);
	        if (doc.getName().equals(msNombrevista)) {
	            try {
	            	MapContext loContext = ((ProjectView)doc).getMapContext().cloneToDraw();
	    			
	                loContext.getViewPort().setImageSize(
	                		new Dimension(
	                				plWidth, 
	                				plHeight) 
	                		);
	                loContext.zoomToExtent(poRect);
                    loContext.draw(
                            loImage,
                            loGra,
                            loContext.getScaleView()
                            );	                
	            } catch (Exception e1) {
	    			// TODO Auto-generated catch block
	    			e1.printStackTrace();
	    		}
	            
	        }
	    }
	    
	    return loImage;
	}

    public String getNombre() {
        return msNombrevista;
    }
	
	
	
	
}
